﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _2_NamedParameters
{
    class Program
    {
        static void Main(string[] args)
        {
            // email optional, no problem
            AddClubMember("J", dateJoined: DateTime.Now);

            // can specify names explicitly for all args
            AddClubMember(name: "Joe", dateJoined: DateTime.Now);

            // order for named parameters doesn't matter
            AddClubMember(email: "joe@dot.net", name: "Joe", dateJoined: DateTime.Now);
            
            // still works with a normal call
            AddClubMember("Tony", "tony@hisdomain.com", DateTime.Now);

            // domain optional, no problem
            AddClubMember("May", "may@herdomain.com");

            // error: name not optional
            // AddClubMember(email: "joe@dot.net", dateJoined: DateTime.Now);

            // logical error because email address is passed to name
            AddClubMember("joe@someplace.org", dateJoined: DateTime.Now);
        }

        public static void AddClubMember(
            string name, 
            string email = "", 
            DateTime? dateJoined = null)
        {
            // not yet implemented
        }
    }
}
