﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _3_DynamicLookup
{
    class Program
    {
        static void Main(string[] args)
        {
            var prog = new Program();

            prog.UseDynamicOnObject();
            //prog.IterateObjects();
            //prog.PerformConversions();

            Console.ReadKey();
        }

        private void PerformConversions()
        {
            string normalString = "My String";
            dynamic dynamicString = normalString;
            string stringResult = dynamicString;

            int normalInt = 7;
            dynamic dynamicInt = normalInt;
            int intResult = dynamicInt;

            //string notString = dynamicInt;
        }

        #region Dynamic Lookup on Type Object

        private void UseDynamicOnObject()
        {
            dynamic flyingThing = GetFlyingThing();
            bool isBird = flyingThing is Bird;
            flyingThing.Fly();
        }

        public object GetFlyingThing()
        {
            return new Bird();
        }

        #endregion

        #region Iterating over multiple objects

        public void IterateObjects()
        {
            foreach (dynamic flyingThing in GetFlyingObjects())
            {
                flyingThing.Fly();
            }
        }

        public IEnumerable<object> GetFlyingObjects()
        {
            yield return new Airplane();
            yield return new Bird();
            yield return new Tree();
        }

        #endregion
    }
}
