﻿using System.Reflection;
using Excel = Microsoft.Office.Interop.Excel;

class Program
{
    static void Main()
    {
        ExecuteInteropOld();
        ExecuteInteropNew();
    }

    private static void ExecuteInteropOld()
    {
        var excelApp = new Excel.ApplicationClass();

        excelApp.Visible = true;

        var wkBook = excelApp.Workbooks.Add(Missing.Value);
        var wkSheetData = (Excel.Worksheet)wkBook.ActiveSheet;

        wkSheetData.Cells[1, 1] = "Name";
        wkSheetData.Cells[1, 2] = "Email";

        var data = new string[,]
            {
                {"Joe Mayo", "jmayo@mayosoftware.com"},
                {"Jane Doe", "jdoe@smith.com"}
            };

        var dataRange = wkSheetData.get_Range("A2", "B3");
        dataRange.Value2 = data;

        var wkSheetEnd = (Excel.Worksheet)wkBook.Worksheets.Add(
            Missing.Value, wkSheetData, Missing.Value, Missing.Value);

        wkSheetEnd.Cells[2, 2] = "Second Sheet";

        wkBook.SaveAs(
            "myfile.xls", Missing.Value, Missing.Value,
            Missing.Value, Missing.Value, Missing.Value,
            Excel.XlSaveAsAccessMode.xlShared, Missing.Value, Missing.Value,
            Missing.Value, Missing.Value, Missing.Value);
    }

    private static void ExecuteInteropNew()
    {
        var excelApp = new Excel.ApplicationClass();
        excelApp.Visible = true;

        dynamic wkBook = excelApp.Workbooks.Add();
        Excel.Worksheet wkSheetData = wkBook.ActiveSheet;

        wkSheetData.Cells[1, 1] = "Name";
        wkSheetData.Cells[1, 2] = "Email";

        var data = new string[,]
            {
                {"Joe Mayo", "jmayo@mayosoftware.com"},
                {"Jane Doe", "jdoe@smith.com"}
            };

        var dataRange = wkSheetData.get_Range("A2", "B3");
        dataRange.Value2 = data;

        Excel.Worksheet wkSheetEnd =
            wkBook.Worksheets.Add(After: wkSheetData);

        wkSheetEnd.Cells[2, 2] = "Second Sheet";

        wkBook.SaveAs(
            "myfile.xls",
            Excel.XlSaveAsAccessMode.xlShared);
        //wkBook.SaveAs(
        //    "myfile.xls",
        //    AccessMode: Excel.XlSaveAsAccessMode.xlShared);
    }
}