﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _5_Variance
{
    class Program
    {
        static void Main(string[] args)
        {
            VarianceBasics();
            ImplementInterfaceCovariance();
            ImplementInterfaceContravariance();
            ImplementDelegateCovariance();
        }

        private static void VarianceBasics()
        {
            string[] strings = new string[] { "one", "two", "three" };
            object[] objects = strings;
            string[] strings2 = (string[])objects;


            IEnumerable<string> strings3 = strings;
            IEnumerable<object> objects3 = strings3;
            IEnumerable<string> strings4 = (IEnumerable<string>)objects3;
        }

        private static void ImplementInterfaceContravariance()
        {
            IHaveBinaryEquality<Vehicle> vehCmp = new Vehicle();
            IHaveBinaryEquality<Truck> truckCmp = vehCmp;
        }

        private static void ImplementInterfaceCovariance()
        {
            IUseGas<Car> gasCar = new GasEngineVehicle<Car>();
            IUseGas<Vehicle> gasVehicle = gasCar;
        }

        private delegate TResult ActionFunc<in TParam, out TResult>(TParam param);

        private static void ImplementDelegateCovariance()
        {
            ActionFunc<Car, Vehicle> myAction = ActionFuncHandlerMethod;
        }

        private static Car ActionFuncHandlerMethod(Vehicle car)
        {
            return new Car();
        }
    }
}
